
package pg.ntnu.eti.ibm.master.thesis.paralysis.server;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.logging.Level;
import java.util.logging.Logger;
import org.opencv.core.Core;
import static org.opencv.core.Core.FONT_HERSHEY_PLAIN;
import org.opencv.core.Mat;
import org.opencv.core.MatOfRect;
import org.opencv.core.Point;
import org.opencv.core.Rect;
import org.opencv.core.Scalar;
import org.opencv.core.Size;
import org.opencv.objdetect.CascadeClassifier;

/**
 *
 * @author akwasnie
 */
public class AreasFinder {

    static ArrayList<Object> findFace(Mat image) {
        ArrayList<Object> a = new ArrayList<>();
        File file = new File("/home/ubuntu/haarcascade_frontalface_default.xml");
        File file2 = new File("/home/ubuntu/haarcascade_eye.xml");
        File file3 = new File("/home/ubuntu/haarcascade_msc_mouth.xml");

        CascadeClassifier faceDetector = new CascadeClassifier(file.getPath());
        CascadeClassifier eyeDetector = new CascadeClassifier(file2.getPath());
        CascadeClassifier mouthDetector = new CascadeClassifier(file3.getPath());

        MatOfRect faceDetections = new MatOfRect();
        MatOfRect eyeDetections = new MatOfRect();
        MatOfRect mouthDetections = new MatOfRect();
        Mat facef = new Mat();
        Rect r = new Rect();

        faceDetector.detectMultiScale(image, faceDetections);

        System.out.println(String.format("Detected %s faces", faceDetections.toArray().length));

        for (Rect rect : faceDetections.toArray()) {

            Core.rectangle(image, new Point(rect.x, rect.y), new Point(rect.x + rect.width, rect.y + rect.height),
                    new Scalar(0, 255, 0));

            Mat face = image.submat(rect);
            mouthDetector.detectMultiScale(face, mouthDetections, 1.1, 2, 0, new Size(30, 30), new Size());
            Rect[] toArray = mouthDetections.toArray();
            Rect[] firstHalf;
            if (toArray.length > 0) {
                firstHalf = Arrays.copyOfRange(toArray, 0, 1);
            } else {
                firstHalf = toArray.clone();
            }

            ArrayList<Point> mouthCentres = new ArrayList<>();
            for (Rect mouth : firstHalf) {

                Core.rectangle(face, new Point(mouth.x + 5, mouth.y), new Point(mouth.x + mouth.width - 5, mouth.y + mouth.height), new Scalar(0, 255, 0));

                Point center = new Point((mouth.x + 10), (mouth.y + mouth.height * 1 / 3));
                Core.circle(face, center, 2, new Scalar(0, 0, 255));

                Point center2 = new Point((mouth.x + mouth.width - 10), (mouth.y + mouth.height * 1 / 3));
                Core.circle(face, center2, 2, new Scalar(0, 0, 255));

                mouthCentres.add(center);
                mouthCentres.add(center2);

            }
            facef = face.clone();
            r = rect;

            Mat crop = face.submat(4, (2 * face.width()) / 3, 0, face.height());

            eyeDetector.detectMultiScale(crop, eyeDetections, 1.1, 2, 0, new Size(10, 10), new Size());
            System.out.println("" + eyeDetections.size());
            Rect[] toArray1 = eyeDetections.toArray();
            Rect[] array = Arrays.copyOfRange(toArray1, 0, 2);
            ArrayList<Point> eyeCentres = new ArrayList();
            for (Rect rect2 : toArray1) {
                Core.rectangle(crop, new Point(rect2.x, rect2.y), new Point(rect2.x + rect2.width, rect2.y + rect2.height),
                        new Scalar(0, 255, 0));
                Point center = new Point((rect2.x + rect2.width / 2), (rect2.y + rect2.height / 2));
                Core.circle(crop, center, 2, new Scalar(0, 255, 0));
                eyeCentres.add(center);
            }

            crop.copyTo(facef.submat(4, (2 * face.width()) / 3, 0, face.height()));
            facef.copyTo(image.submat(rect));
            double[] countLength = LengthCount.countLength(eyeCentres, mouthCentres);
            System.out.println(countLength[0]);
            System.out.println(countLength[1]);
            Rect re = new Rect(0, 0, image.width(), image.height() * 1 / 6);
            Core.rectangle(image, new Point(re.x, re.y), new Point(re.x + re.width, re.y + re.height),
                    new Scalar(0, 0, 0), -1);
            double leftToRight = countLength[0] / countLength[1];
            Core.putText(image, String.valueOf(leftToRight), new Point(5, 15), FONT_HERSHEY_PLAIN, 0.6, new Scalar(255, 255, 255));

        }
        if (!facef.empty()) {
            Rect re = new Rect(0, 0 + facef.height() / 4 * 2, facef.width() / 2, facef.height() * 1 / 4);
            Mat halfLeft = facef.submat(re);
            Core.rectangle(facef, new Point(re.x, re.y), new Point(re.x + re.width, re.y + re.height),
                    new Scalar(0, 0, 0));

            Rect rer = new Rect(0 + facef.width() / 2, 0 + facef.height() / 4 * 2, facef.width() / 2, facef.height() * 1 / 4);
            Mat halfRight = facef.submat(rer);
            Core.rectangle(facef, new Point(rer.x, rer.y), new Point(rer.x + rer.width, rer.y + rer.height),
                    new Scalar(0, 0, 0));

            try {

                String colorLeft = String.valueOf(ColorsCount.PrintColorsMap(ColorsCount.GetCount(ColorsCount.convert(halfLeft)))).replace("java.awt.Color", "");
                String colorRight = String.valueOf(ColorsCount.PrintColorsMap(ColorsCount.GetCount(ColorsCount.convert(halfRight)))).replace("java.awt.Color", "");
                Core.putText(image, String.valueOf(colorLeft), new Point(5, 25), FONT_HERSHEY_PLAIN, 0.6, new Scalar(255, 255, 255));
                Core.putText(image, String.valueOf(colorRight), new Point(5, 35), FONT_HERSHEY_PLAIN, 0.6, new Scalar(255, 255, 255));

            } catch (IOException ex) {
                Logger.getLogger(FramesConverter.class.getName()).log(Level.SEVERE, null, ex);
            }

            a.add(r);
            a.add(facef);
            a.add(image);
        }

        return a;
    }
}
