package pg.ntnu.eti.ibm.master.thesis.paralysis.server;


import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.util.ArrayList;
import java.util.logging.Level;
import java.util.logging.Logger;
import org.eclipse.jetty.websocket.WebSocket;

    class FaceDetectWebSocket implements WebSocket,
            WebSocket.OnBinaryMessage, WebSocket.OnTextMessage {

        private Connection connection;
        private final FramesConverter faceDetection = new FramesConverter();
        private ArrayList<byte[]> al = new ArrayList<>();
        private ArrayList<byte[]> rl = new ArrayList<>();
        private int number = 0;
        private final FramesSaver framesSaver = new FramesSaver();

        public FaceDetectWebSocket() {
            super();
        }

        @Override
        public void onOpen(Connection connection) {
            this.connection = connection;
            this.connection.setMaxBinaryMessageSize(1024 * 512);
        }

        @Override
        public void onClose(int code, String message) {
        }

        @Override
        public void onMessage(byte[] data, int offset, int length) {

            ByteArrayOutputStream bOut = new ByteArrayOutputStream();
            bOut.write(data, offset, length);
            try {
                al.add(bOut.toByteArray());
                if (al.size() == 2) {
                    rl = faceDetection.convert(al);
                    framesSaver.saveFrames(rl);
                    if (rl.size() > 1) {
                        for (int i = 0; i < rl.size(); i++) {
                            this.connection.sendMessage(rl.get(i), 0, rl.get(i).length);
                            Thread.sleep(50);
                        }
                    } else {
                        this.connection.sendMessage("failed");
                    }
                    al.clear();

                }

            } catch (IOException e) {

            } catch (InterruptedException ex) {
                Logger.getLogger(WebsocketServer.class.getName()).log(Level.SEVERE, null, ex);
            }
        }

        @Override
        public void onMessage(String string) {
            throw new UnsupportedOperationException("Not supported yet."); 
        }
    }


	