
package pg.ntnu.eti.ibm.master.thesis.paralysis.server;

import java.awt.image.BufferedImage;
import java.awt.image.DataBufferByte;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.imageio.ImageIO;
import org.opencv.core.CvType;
import org.opencv.core.Mat;
import org.opencv.core.MatOfByte;
import org.opencv.highgui.Highgui;

/**
 *
 * @author akwasnie
 */
public class FormatConverter {
     public static Mat changetoMat(byte[] get) {
        Mat image = new Mat();
        try {
            InputStream in1 = new ByteArrayInputStream(get);

            BufferedImage imBuff = ImageIO.read(in1);

            image = new Mat(imBuff.getHeight(), imBuff.getWidth(), CvType.CV_8UC3);
            byte[] pixels = ((DataBufferByte) imBuff.getRaster().getDataBuffer()).getData();
            image.put(0, 0, pixels);

        } catch (IOException ex) {
            Logger.getLogger(FramesConverter.class.getName()).log(Level.SEVERE, null, ex);
        }
        return image;
    }
     public static byte[] matToByte(Mat image) {
        ByteArrayOutputStream bout = new ByteArrayOutputStream();
        try {

            MatOfByte bytemat = new MatOfByte();
            Highgui.imencode(".png", image, bytemat);
            byte[] bytes = bytemat.toArray();
            InputStream in = new ByteArrayInputStream(bytes);
            BufferedImage imgb = ImageIO.read(in);

            in.close();

            ImageIO.write(imgb, "png", bout);

        } catch (IOException ex) {
            Logger.getLogger(FramesConverter.class.getName()).log(Level.SEVERE, null, ex);
        }
        return bout.toByteArray();
    }
    
}
