package pg.ntnu.eti.ibm.master.thesis.paralysis.server;

import java.io.File;
import java.util.ArrayList;
import org.opencv.core.Core;
import org.opencv.core.Mat;
import org.opencv.core.Rect;
import org.opencv.imgproc.Imgproc;

/**
 *
 * @author akwasnie
 */
public class FramesConverter {

   
    ArrayList<Mat> lowpass1 = new ArrayList<>();
    ArrayList<Mat> lowpass2 = new ArrayList<>();
   

    static {
        String libopencv = new File("/root/opencv-2.4.9/build/lib/libopencv_java249.so").getAbsolutePath();
        System.load(libopencv);
    }



    public FramesConverter() {

    }


    ArrayList<byte[]> convert(ArrayList<byte[]> al) {
        ArrayList<byte[]> byteArray = new ArrayList<>();
        ArrayList<Mat> imagesMat = new ArrayList<>();
        ArrayList<Mat> facesArray = new ArrayList<>();
        ArrayList<Mat> facesArrayProc = new ArrayList<>();
        ArrayList<Mat> facesArrayProc2 = new ArrayList<>();
        ArrayList<Mat> imArray = new ArrayList<>();
        ArrayList<Rect> rectArray = new ArrayList<>();
        ArrayList<Mat> retArray = new ArrayList<>();
        lowpass1.clear();
        lowpass2.clear();

        for (int i = 0; i < al.size(); i++) {
            Mat b = FormatConverter.changetoMat(al.get(i));
            imagesMat.add(b);
        }
        for (int i = 0; i < imagesMat.size(); i++) {
            ArrayList<Object> b = AreasFinder.findFace(imagesMat.get(i));
            if (b.size() > 0) {
                facesArray.add((Mat) b.get(1));
                imArray.add((Mat) b.get(2));
                rectArray.add((Rect) b.get(0));
                imArray.add((Mat) b.get(2));
                rectArray.add((Rect) b.get(0));
            }
        }
        if (facesArray.size() > 1) {
            System.out.println("facearray " + facesArray.size());
            facesArrayProc = ColorMagnifier.change((ArrayList<Mat>) facesArray.clone());
            facesArrayProc2 = MotionMagnifier.move((ArrayList<Mat>) facesArray.clone());

            for (int i = 0; i < facesArrayProc2.size(); i++) {

                Mat f = facesArrayProc2.get(i);
                Mat f2 = facesArrayProc.get(i);
                f2.convertTo(f2, f.type());
                Imgproc.resize(f2, f2, f.size());
                Core.add(f2, f, f);

                Mat im = imArray.get(i);
                Rect r = rectArray.get(i);
                f.copyTo(im.submat(r));
                retArray.add(im);
            }

            for (int i = 0; i < retArray.size(); i++) {
                byte[] b = FormatConverter.matToByte(retArray.get(i));
                byteArray.add(b);
            }
        }
        return byteArray;
    }

}
