package pg.ntnu.eti.ibm.master.thesis.paralysis.server;

import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.StandardCopyOption;
import java.util.ArrayList;
import java.util.zip.ZipEntry;
import java.util.zip.ZipInputStream;
import java.util.zip.ZipOutputStream;

/**
 *
 * @author akwasnie
 */
public class FramesSaver {

    File file = new File("1.zip");
    int counter = 0;

    public void saveFrames(ArrayList<byte[]> rl) {
        try {

            final File tempFile = File.createTempFile("abc", "def");

            try (ZipOutputStream zos = new ZipOutputStream(new FileOutputStream(tempFile))) {
                copyEntries(file, zos);
                saveNewFrames(zos, rl);
                zos.close();
            }

            Files.move(tempFile.toPath(), file.toPath(), StandardCopyOption.REPLACE_EXISTING);

        } catch (IOException ex) {

        }
    }

    private void saveNewFrames(final ZipOutputStream zos, ArrayList<byte[]> list) throws IOException {
        for (byte[] frame : list) {

            saveNewFrame(zos, frame);
        }
    }

    private void saveNewFrame(ZipOutputStream zos, byte[] buffer) throws IOException {
        counter++;
        ZipEntry ze = new ZipEntry(String.valueOf(counter) + ".jpg");
        zos.putNextEntry(ze);
        zos.write(buffer, 0, buffer.length);
        zos.closeEntry();
    }

    private void copyEntries(final File file, ZipOutputStream zos) throws IOException {
        try (final ZipInputStream zis = new ZipInputStream(new FileInputStream(file))) {
            ZipEntry zipEntry = zis.getNextEntry();
            while (zipEntry != null) {
                copyEntry(zipEntry, zis, zos);
                zipEntry = zis.getNextEntry();
            }
        } catch (FileNotFoundException exception) {
        }
    }

    private void copyEntry(ZipEntry zipEntry, ZipInputStream zis, ZipOutputStream zos) throws IOException {
        byte[] buffer = new byte[100];
        int count;

        try (ByteArrayOutputStream baos = new ByteArrayOutputStream()) {
            while ((count = zis.read(buffer, 0, buffer.length)) != -1) {
                baos.write(buffer, 0, count);
            }

            zos.putNextEntry(zipEntry);
            zos.write(baos.toByteArray());
            zos.closeEntry();
        }
    }

    private void saveData() {
    //TBD
    }

}
