package pg.ntnu.eti.ibm.master.thesis.paralysis.server;

import java.util.logging.Logger;
import javax.servlet.http.HttpServletRequest;
import org.eclipse.jetty.server.Server;
import org.eclipse.jetty.server.nio.SelectChannelConnector;
import org.eclipse.jetty.websocket.WebSocket;
import org.eclipse.jetty.websocket.WebSocketHandler;

/**
 *
 * @author akwasnie
 */
public class WebsocketServer extends Server {

    private final static Logger LOG = Logger.getLogger(WebsocketServer.class.getName());

    public WebsocketServer(int port) {
        SelectChannelConnector connector = new SelectChannelConnector();
        connector.setHost("ec2-52-24-99-202.us-west-2.compute.amazonaws.com");
        connector.setPort(port);
        addConnector(connector);

        WebSocketHandler wsHandler = new WebSocketHandler() {
            @Override
            public WebSocket doWebSocketConnect(HttpServletRequest request, String protocol) {
                return new FaceDetectWebSocket();
            }
        };
        setHandler(wsHandler);
    }

    /**
     * Start the server on port 999
     *
     * @param args
     * @throws java.lang.Exception
     */
    public static void main(String[] args) throws Exception {
        WebsocketServer server = new WebsocketServer(9999);
        server.start();
        server.join();
    }
}
